/*
    Project: TCGINA
    Version: V1.21
    File   : kfedit.c

    Copyright (c) 2005-2008 Author of TCGINA DLL. All rights reserved.
    Public Key Fingerprint: 294B A769 4A0A CC05 DAE6 00DD FF47 8C72 4097 67CE

    Covered by TrueCrypt License 2.3 the full text of which is contained
    in the file License.txt included in TCGINA binary and source code
    distribution archives.

    The copyright notice of this source code file and the public key
    fingerprint must be retained in full.
*/

#include "kfdlg.h"
#include "random.h"
#include "secmem.h"
#include "misc.h"

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
  LPSTR lpCmdLine, int nCmdShow)
{
    KF_DIALOG_DATA kfdd;
    LPWSTR         *wszArgList;
    int            nArgs;
#ifdef KFI_DEBUG
    SEC_HEAP_INFORMATION shi;
#endif

    UNREFERENCED_PARAMETER(hPrevInstance);
    UNREFERENCED_PARAMETER(lpCmdLine);
    UNREFERENCED_PARAMETER(nCmdShow);

    InitRandom();

#ifdef KFI_DEBUG
    if (!KFI_Test()) {
        return KFIE_FAIL_TESTVECTOR;
    }
#endif

    memset(&kfdd, '\0', sizeof(kfdd));
    kfdd.hInstance = hInstance;
    kfdd.pSecData = (PKF_SEC_DATA)sec_malloc(sizeof(KF_SEC_DATA));
    if (kfdd.pSecData == 0) return KFIE_MEM;
    memset(kfdd.pSecData, '\0', sizeof(KF_SEC_DATA));

    wszArgList = CommandLineToArgvW(GetCommandLineW(), &nArgs);
    if (wszArgList) {
        if (nArgs == 2) {
            CopyString(kfdd.szFileName, countof(kfdd.szFileName),
              wszArgList[1]);
        }
        LocalFree(wszArgList);
    }

    KF_Edit(&kfdd);
    sec_free(kfdd.pSecData);

    DestroyRandom();

#ifdef KFI_DEBUG
    sec_heap_compact();
    if (sec_heap_status(&shi)) {
        if (shi.cAllocations != 0 || shi.cbAllocationSize != 0) {
            return KFIE_MEM;
        }
    }
#endif

    return 0;
}